<template>
	<xn-form-container
		:title="pageType === 'EDIT' ? '编辑物料' : pageType === 'ADD' ? '增加物料' : '查看物料'"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-row :gutter="16">
				<a-col :span="24">
					<a-form-item label="编码：" name="number">
						<a-input
							:disabled="pageType === 'SEARCH'"
							v-model:value="formData.number"
							placeholder="请输入编码"
							allow-clear
						/>
					</a-form-item>
				</a-col>
				<a-col :span="24">
					<a-form-item label="名称：" name="name">
						<a-input
							:disabled="pageType === 'SEARCH'"
							v-model:value="formData.name"
							placeholder="请输入物料名称"
							allow-clear
						/>
					</a-form-item>
				</a-col>
				<a-col :span="24">
					<a-form-item label="上级物料：" name="parentId">
						<a-tree-select
							:disabled="pageType === 'SEARCH'"
							v-model:value="formData.parentId"
							style="width: 100%"
							:dropdown-style="{ maxHeight: '400px', overflow: 'auto' }"
							:tree-data="treeData"
							placeholder="请选择上级物料"
							:fieldNames="{
								children: 'children',
								label: 'name',
								value: 'id'
							}"
						>
						</a-tree-select>
					</a-form-item>
				</a-col>
			</a-row>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button v-if="pageType !== 'SEARCH'" type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="productionOrganizationForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import productionOrganizationApi from '@/api/base/production-organization/productionOrganizationApi'
	import sysStoreApi from '@/api/base/store/sysStoreApi'
	import materialCategoryApi from '@/api/base/material/materialCategoryApi'
	// 抽屉状态
	const visible = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	let formData_enum = {
		type: 'FACTORY',
		enabledState: 'ENABLE'
	}
	const formData = ref({})
	const submitLoading = ref(false)
	const typeOptions = ref([])
	const enabledStateOptions = ref([])
	let pageType = ref('ADD')

	// 打开抽屉
	const onOpen = (record) => {
		visible.value = true
		if (record) {
			pageType.value = record.pageType
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		} else {
			pageType.value = 'ADD'
			formData.value = formData_enum
		}

		materialCategoryApi.materialCategoryTree().then((res) => {
			treeData.value = [
				{
					id: 0,
					parentId: '0',
					name: '顶级',
					children: res ? res : []
				}
			]
		})
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		visible.value = false
	}
	// 默认要校验的refresh
	const formRules = {
		name: [required('请输入名称')],
		parentId: [required('请选择上级物料')]
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value.validate().then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)

			materialCategoryApi
				.materialCategorySubmitForm(formDataParam, formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
	}

	let treeData = ref([])
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
